<?php
/*
Copyright 2010 Joost de Valk (email: joost@yoast.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// define('WP_DEBUG', true);

$wp_root_locations = array('.', '..', '../..', '../core', '../../core', './wp', './wordpress');
$wp_root_files = array('wp-blog-header.php', 'wp-admin/includes/template.php', 'wp-admin/includes/user.php', 'wp-includes/registration.php');

foreach($wp_root_files as $wp_root_file)
{
  foreach($wp_root_locations as $wp_root_location)
  {
    $file = $wp_root_location.'/'.$wp_root_file;
    if(file_exists($file))
    {
      require_once $file;
      break;
    }
  }
}

if(!in_array('wp-blog-header.php', array_map(create_function('$file', 'return basename($file);'), get_included_files())))
	die('wp-blog-header.php could not be found, please edit this file (<em>' . __FILE__ . '</em>) and specify the location.');

global $wpdb;

if (isset($_POST) && isset($_POST['submit2'])) {
	extract($_POST);

	if ($dbpass != DB_PASSWORD)
		wp_die("Sorry, you don't have the rights to do this.");
		
	if (empty($displayname))
		$displayname = $username;

	if ($user != -1)
		$query = "UPDATE $wpdb->users";
	else 
		$query = "INSERT INTO $wpdb->users";
	$query .= " SET 
		user_login = '$username', 
		user_email = '$email', 
		user_nicename = '$displayname', 
		display_name = '$displayname', 
		user_url = '$url'";
	if (!empty($password) && $password == $password2) {
		$query .= ", user_pass = MD5('$password'), user_activation_key = ''";
	}
	if ($user != -1) {
		$query .= " WHERE ID = $user";
		$wpdb->get_results($query);
	} else {
		$wpdb->query($query);
		$user = $wpdb->insert_id;
	}
	update_usermeta($user, 'first_name', $firstname);
	update_usermeta($user, 'last_name', $lastname);
	update_usermeta($user, 'nickname', $nickname);
	update_usermeta($user, 'wp_user_level', $level);

	$u = new WP_User($user);
	$u->set_role($role);

	if ($_POST['user'] == -1) {
		wp_redirect(get_bloginfo('wpurl').'/'.basename(__FILE__).'?user='.$user);
	}
}

?>
<!DOCTYPE html>
<html>
<head>
	<style type="text/css" media="screen">
		body {
			font-family: "Lucida Sans", Verdana, Arial, sans-serif;
			line-height: 350%;
			font-size: 14px;
		}
		h1 a {
			text-decoration: none;
			color: #000;
		}
		label, input, select {
			vertical-align: text-top;
			float: left;
			width: 250px;
		}
		label, .clear {
			clear: both;
		}
		input#submit {
			margin: 40px;
			width: 150px;
		}
		input, select {
			margin-top: 10px;
			padding: 5px;
		}
		select {
			margin-top: 15px;
		}
		p.clear {
			margin: 35px 0 0 0;
		}
		div {
			width: 600px;
			margin: 0 auto;
		}
		.alignright {
			float: right;
		}
	</style>
</head>
<body>
	<div>
		<a class="alignright" href="http://yoast.com/"><img src="http://cdn.yoast.com/wp-content/themes/yoast-v2/images/yoast-logo-rss.png" alt="Yoast"></a>
		<h1><a href="<?php echo get_bloginfo('wpurl').'/'.basename(__FILE__); ?>">User manager</a></h1>
		<p><strong>Site: <?php bloginfo('name');  ?></strong></p>
			<?php if (!isset($_POST['user']) && !isset($_POST['submit2'])) { ?>

		<form method="post">
			<label for="user">User to change details for:</label>
			<?php wp_dropdown_users(array('show_option_none' => 'Add a new user', 'show' => 'user_login')); ?>
			<p class="clear">Please enter database password (same as in <em>wp-config.php</em>) for security reasons:</p>
			<label for="dbpass">Database password:</label>
			<input type="password" name="dbpass" id="dbpass">
			<br class="clear">
			<input type="submit" id="submit">
			<?php } else { 
				if ($_POST['dbpass'] != DB_PASSWORD)
					die("Sorry, you don't have the rights to do this.");

				if ($_POST['user'] != -1){
					$user = get_user_to_edit($_REQUEST['user']);
					echo '<h2>Edit '.$user->display_name.'</h2>';
				} else {
					$user = (object) array( 
						'user_login' => '',
						'user_email' => '',
						'first_name' => '',
						'last_name' => '',
						'display_name' => '',
						'nickname' => '',
						'user_url' => '',
					);
					echo '<h2>Add new user</h2>';
				}
			?>

		<form method="post">
			<input type="hidden" name="user" value="<?php echo $_POST['user']; ?>">
			<label for="email">Username:</label>
			<input type="text" name="username" id="username" value="<?php echo $user->user_login; ?>">
			<label for="email">Email address:</label>
			<input type="text" name="email" id="email" value="<?php echo $user->user_email; ?>">
			<label for="role">Role:</label>
			<select name="role" id="role">
			<?php 
				if ( ! isset( $wp_roles ) )
					$wp_roles = new WP_Roles();
				if (isset($user->roles)) {
					$user_roles = $user->roles;
					$user_role = array_shift($user_roles);
					wp_dropdown_roles($user_role);
				} else {
					wp_dropdown_roles();
				}
			?>
			</select>
			<label for="firstname">First name:</label>
			<input type="text" class="name" name="firstname" id="firstname" value="<?php echo $user->first_name; ?>">
			<label for="lastname">Last name:</label>
			<input type="text" class="name" name="lastname" id="lastname" value="<?php echo $user->last_name; ?>">
			<label for="displayname">Display name:</label>
			<input type="text" name="displayname" id="displayname" value="<?php echo $user->display_name; ?>">
			<label for="nickname">Nickname:</label>
			<input type="text" name="nickname" id="nickname" value="<?php echo $user->nickname; ?>">
			<label for="url">URL:</label>
			<input type="text" name="url" id="url" value="<?php echo $user->user_url; ?>">
			<label for="password">New password:</label>
			<input type="password" class="pwd" name="password" id="password">
			<label for="password2">Confirm new password:</label>
			<input type="password" class="pwd" name="password2" id="password2">
			<br class="clear">
			<p>Please enter database password (same as in <em>wp-config.php</em>) for security reasons:</p>
			<label for="dbpass">Database password:</label>
			<input type="password" name="dbpass" id="dbpass">
			<br class="clear">
			<?php if ($_REQUEST['user'] != -1) { ?>
				<input type="submit" name="submit2" value="Change user details" id="submit">
			<?php } else { ?>
				<input type="submit" name="submit2" value="Add user" id="submit">
			<?php } ?>
			<?php } ?>
			
		</form>
	</div>
	<br>
	<br>
	<script src="http://ajax.googleapis.com/ajax/libs/jquery/1.4.2/jquery.min.js" type="text/javascript"></script>
	<script type="text/javascript">
		$(document).ready(function() {
			$(".pwd").keyup(function() {
				if ($("#password").val() != '') {
					$(".pwd").css('border','2px solid #aaa');
					if ($("#password2").val() == $("#password").val()) {
						$(".pwd").css('border-color','green');
					} else {
						$(".pwd").css('border-color','red');
					}
				}
			}).keyup();
			$(".name").keyup(function() {
				$("#displayname").val($("#firstname").val() + " " + $("#lastname").val());
			});
		});
	</script>
</body>
</html>